@ECHO OFF
setlocal
SET SIGNMYJARSFILESPATH=%~dp0
echo 1 input values are mandatory
echo 1 name of the properties file
REM echo 2 create or use depending on if you want to create a certifier or use one already created
REM echo 3 long means taking all the values from the properties file and short means that L, ST and C is left out
REM echo 4 algorithm used by certifier. MD5withRSA, SHA1withRSA or SHA256withRSA are valid
echo Example: Signing_myjarsigner.cmd Cool_Signing_wit_XTAF_MD5.jarsigner
IF [%1]==[] (
	ECHO Properties file is Missing
	ECHO please use a valid filename
	EXIT /b 1
)
ECHO Evaluating input
IF EXIST %1 (
for /F "usebackq delims=" %%a in (%1) do set "%%a"
 ) ELSE (
	ECHO Wrong properties file
	EXIT /b 1
)
IF ["%JAVA_HOME%"] EQU [""] (
	ECHO JAVA_HOME is missing
	EXIT /b 1
)
IF ["%ALIAS%"] EQU [""] (
	ECHO ALIAS is missing
	EXIT /b 1
)
IF ["%PASSWORD%"] EQU [""] (
	ECHO PASSWORD is missing
	EXIT /b 1
)
IF ["%JKSDIRECTORY%"] EQU [""] (
	ECHO JKSDIRECTORY is missing
	EXIT /b 1
)
IF ["%JKSFILE%"] EQU [""] (
	ECHO JKSFILE is missing
	EXIT /b 1
)
REM ### ----- Script to perform the work -----
set JAR_SIGNER=%JAVA_HOME%\bin\jarsigner.exe
IF NOT EXIST "%JAR_SIGNER%" (
	ECHO %JAR_SIGNER% is not an existing file
	EXIT /b 1
)
ECHO ALIAS=%ALIAS%
ECHO PASSWORD=%PASSWORD%
ECHO JKSDIRECTORY=%JKSDIRECTORY%
ECHO JKSFILE="%JKSDIRECTORY%\%JKSFILE%.jks"
IF NOT EXIST "%JKSDIRECTORY%\%JKSFILE%.jks" (
	ECHO JKSFILE is missing
	EXIT /b 1
)
IF ["%JARDIRECTORY%"] EQU [""] (
	ECHO JARDIRECTORY is missing
	EXIT /b 1
)
IF ["%JARTSA%"] EQU [""] (
	ECHO JARTSA is missing
	EXIT /b 1
)
IF ["%JARTSADIGESTALG%"] EQU [""] (
	ECHO JARTSADIGESTALG is missing
	EXIT /b 1
)
IF ["%JARSIGFILE%"] EQU [""] (
	ECHO JARSIGFILE is missing
	EXIT /b 1
)
IF ["%JARSIGALG%"] EQU [""] (
	ECHO JARSIGALG is missing
	EXIT /b 1
)
IF ["%JARDIGESTALG%"] EQU [""] (
	ECHO JARDIGESTALG is missing
	EXIT /b 1
)
ECHO JARDIRECTORY=%JARDIRECTORY%
ECHO JARTSA=%JARTSA%
ECHO JARTSADIGESTALG=%JARTSADIGESTALG%
ECHO JARSIGFILE=%JARSIGFILE%
ECHO JARSIGALG=%JARSIGALG%
ECHO JARDIGESTALG=%JARDIGESTALG%
DIR "%JARDIRECTORY%" /S /B > "%SIGNMYJARSFILESPATH%\%1.jarfiles"
ECHO Recording previous signatures > "%SIGNMYJARSFILESPATH%\%1.prevsign"
ECHO Recording current signatures > "%SIGNMYJARSFILESPATH%\%1.currsign"
FOR /F "usebackq delims=" %%b in ("%SIGNMYJARSFILESPATH%\%1.jarfiles") DO (
ECHO "*****************************************************" >> "%SIGNMYJARSFILESPATH%\%1.prevsign"
ECHO "%%b" >> "%SIGNMYJARSFILESPATH%\%1.prevsign"
"%JAR_SIGNER%" -verify -verbose "%%b" >> "%SIGNMYJARSFILESPATH%\%1.prevsign"
ECHO "*****************************************************" >> "%SIGNMYJARSFILESPATH%\%1.currsign"
ECHO "%%b" >> "%SIGNMYJARSFILESPATH%\%1.currsign"
"%JAR_SIGNER%" -keystore "%JKSDIRECTORY%\%JKSFILE%.jks" -verbose -storepass %PASSWORD% -keypass %PASSWORD% -tsa %JARTSA% -tsadigestalg %JARTSADIGESTALG% -sigfile %JARSIGFILE% -sigalg %JARSIGALG% -digestalg %JARDIGESTALG% "%%b" %ALIAS%
"%JAR_SIGNER%" -verify -verbose "%%b" >> "%SIGNMYJARSFILESPATH%\%1.currsign"
)
