@ECHO OFF
setlocal
echo 1 input values are mandatory
echo 1 name of the properties file
REM echo 2 create or use depending on if you want to create a certifier or use one already created
REM echo 3 long means taking all the values from the properties file and short means that L, ST and C is left out
REM echo 4 algorithm used by certifier. MD5withRSA, SHA1withRSA or SHA256withRSA are valid
echo Example: Signing_mykeytool.cmd Cool_Signer.keytool
IF [%1]==[] (
	ECHO Properties file is Missing
	ECHO please use a valid filename
	EXIT /b 1
)
ECHO Evaluating input
IF EXIST %1 (
for /F "usebackq delims=" %%a in (%1) do set "%%a"
 ) ELSE (
	ECHO Wrong properties file
	EXIT /b 1
)
IF ["%JAVA_HOME%"] EQU [""] (
	ECHO JAVA_HOME is missing
	EXIT /b 1
)
IF ["%DNAME%"] EQU [""] (
	ECHO DNAME is missing
	EXIT /b 1
)
IF ["%ALIAS%"] EQU [""] (
	ECHO ALIAS is missing
	EXIT /b 1
)
IF ["%PASSWORD%"] EQU [""] (
	ECHO PASSWORD is missing
	EXIT /b 1
)
IF ["%JKSDIRECTORY%"] EQU [""] (
	ECHO JKSDIRECTORY is missing
	EXIT /b 1
)
IF ["%JKSFILE%"] EQU [""] (
	ECHO JKSFILE is missing
	EXIT /b 1
)
IF ["%SIGALG%"] EQU [""] (
	ECHO SIGALG is missing
	EXIT /b 1
)
REM ### ----- Script to perform the work -----
set KEY_TOOL=%JAVA_HOME%\bin\keytool.exe
IF NOT EXIST "%KEY_TOOL%" (
	ECHO %KEY_TOOL% is not an existing file
	EXIT /b 1
)
ECHO DNAME=%DNAME%
ECHO ALIAS=%ALIAS%
ECHO PASSWORD=%PASSWORD%
ECHO JKSDIRECTORY=%JKSDIRECTORY%
ECHO JKSFILE="%JKSDIRECTORY%\%JKSFILE%.jks"
ECHO CERTFILE="%JKSDIRECTORY%\%JKSFILE%.cer"
ECHO ALGORITM=%SIGALG%
IF NOT EXIST "%JKSDIRECTORY%\%JKSFILE%.jks" (
ECHO Creating jks file
"%KEY_TOOL%" -genkey -v -dname "%DNAME%" -alias %ALIAS% -keystore "%JKSDIRECTORY%\%JKSFILE%.jks" -storepass %PASSWORD% -keypass %PASSWORD% -keyalg RSA -sigalg %SIGALG% -keysize 2048 -validity 10950
"%KEY_TOOL%" -list -v -keystore "%JKSDIRECTORY%\%JKSFILE%.jks" -storepass %PASSWORD% -keypass %PASSWORD%
"%KEY_TOOL%" -export -alias %ALIAS% -file "%JKSDIRECTORY%\%JKSFILE%.cer" -keystore "%JKSDIRECTORY%\%JKSFILE%.jks" -storepass %PASSWORD% -keypass %PASSWORD%
) ELSE (
ECHO jks file already exists
)
